LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity Reg is
   generic
	(
		width : natural :=1
	);
	port
	(
			clk: in STD_LOGIC;
			clearn: in STD_LOGIC;
			P : in STD_LOGIC_VECTOR(width-1 downto 0);	
		   Q : out STD_LOGIC_VECTOR(width -1 downto 0)
	);
end;


architecture behav of Reg is
	constant zero : STD_LOGIC_VECTOR(width-1 downto 0) := (others=>'0');
begin
	process(clk, clearn) is
	begin
		if (clearn='0') then
			Q<=zero;
		elsif (rising_edge(clk)) then
			Q<=P;
		end if;
	end process;
end architecture;
		
		