LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity FourBitAdder is
	port
	(
		A, B : in  std_logic_vector(3 downto 0);
		cin : in std_logic;
		S : out std_logic_vector(3 downto 0);
		cout : out std_logic
	);
end entity;


architecture struct of FourBitAdder is
	signal c1, c2, c3 : std_logic;
begin

FA1: entity work.FullAdder(behav)
	port map (A(0), B(0), cin, S(0), c1);

FA2: entity work.FullAdder(behav)
	port map (A(1), B(1), c1, S(1), c2);

FA3: entity work.FullAdder(behav)
	port map (A(2), B(2), c2, S(2), c3);

FA4: entity work.FullAdder(behav)
	port map (A(3), B(3), c3, S(3), cout);	


end;