LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity FullAdder is
	port
	(
		a, b, ci : in  std_logic;
		s, co : out std_logic
	);
end FullAdder;


architecture behav of FullAdder is
   signal s1 : std_logic;

begin

   s1 <= a xor b;
	s <= s1 xor ci;
	co <= (b and not s1) or (ci and s1);
	
end;