library ieee;
use ieee.std_logic_1164.all;


entity testbench is
end testbench;

architecture tb of testbench is
	constant T_clk : time := 20 ns;
	signal A, B : std_logic_vector(3 downto 0);  -- inputs 
	signal M : std_logic_vector(7 downto 0);  -- outputs
begin
	-- connecting testbench signals
	UUT : entity work.ArrayMultiplier4Bit port map ( A, B, M );

	-- signals
	process
	begin
	A <= "0000"; 
	B <= "0001";
	wait for 20 ns;
	A <= "0001"; 
	B <= "0001";
	wait for 20 ns;
	A <= "0010"; 
	B <= "0010";
	wait for 20 ns;
	A <= "1111"; 
	B <= "1111";
	wait for 20 ns;
	A <= "1000"; 
	B <= "1000";
	wait;
	end process;
end tb ;