library ieee;
use ieee.std_logic_1164.all;


entity testbench1 is
end testbench1;

architecture tb of testbench1 is
	constant T_clk : time := 20 ns;
	signal A, B, S : std_logic_vector(3 downto 0);  -- inputs 
	signal cin, cout: std_logic;
	signal M : std_logic_vector(7 downto 0);  -- outputs
begin
	-- connecting testbench signals
	UUT : entity work.FourBitAdder port map ( A, B, cin, S, cout );

	-- signals
	process
	begin
	A <= "0000"; 
	B <= "0001";
	cin <='0';
	wait for 20 ns;
	A <= "0001"; 
	B <= "0001";
	wait for 20 ns;
	A <= "0010"; 
	B <= "0010";
	wait for 20 ns;
	A <= "1111"; 
	B <= "1111";
	wait for 20 ns;
	A <= "1000"; 
	B <= "1000";
	wait;
	end process;
end tb ;