LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity Reg is
   generic
	(
		width : natural :=1
	);
	port
	(
			clk: in STD_LOGIC;
			resetn: in STD_LOGIC;
			load: in STD_LOGIC;
			P : in STD_LOGIC_VECTOR(width-1 downto 0);	
		   Q : out STD_LOGIC_VECTOR(width -1 downto 0)
	);
end;


architecture behav of Reg is
	constant zero : STD_LOGIC_VECTOR(width-1 downto 0) := (others=>'0');
	--signal Qin : STD_LOGIC_VECTOR(width-1 downto 0) := (others=>'0');
begin
--	process(load, resetn, P) is
--	begin
--		if (resetn='0') then
--			Qin<=zero;
--		elsif (load='1') then
--			Qin<=P;
--		end if;
--	end process;
--	
--	process(clk) is
--	begin
--		if (rising_edge(clk)) then
--			Q<=Qin;
--		end if;
--	end process;

   process(clk,resetn) is
	begin
		if (resetn='0') then
		   Q<=zero;
		elsif (rising_edge(clk) AND load='1') then
		   Q<=P;
		end if;
	end process;
		   

end architecture;
		
		