LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_signed.all;

entity part3 is
	port
	(
		   SW  : in STD_LOGIC_VECTOR(7 downto 0);	
			LEDR: out STD_LOGIC_VECTOR(7 downto 0);
			HEX0 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX2 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX4 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX5 : OUT STD_LOGIC_VECTOR(0 TO 6)		
	);
end;


architecture behav of part3 is
   signal A, B : std_logic_vector(3 downto 0);
	signal Mult : std_logic_vector(7 downto 0);	
begin


  A <= SW(7 downto 4) ;
  B <= SW(3 downto 0) ;
  LEDR(7 downto 0) <= SW(7 downto 0);
  
Amult: entity work.ArrayMultiplier4Bit
		port map (A, B, Mult);
				
H0: 
   entity work.DisplayDigit PORT MAP (B, HEX0);	
H2: 
   entity work.DisplayDigit PORT MAP (A, HEX2);	
H4: 
   entity work.DisplayDigit PORT MAP (Mult(3 downto 0), HEX4);		
H5: 
   entity work.DisplayDigit PORT MAP (Mult(7 downto 4), HEX5);	
	

end architecture;
	
	
	
